<?php
require_once("cors.php");
require_once("includes/general.class.php");

$general = new general();

if ($_SERVER['REQUEST_METHOD'] === 'POST')
{
    // Check if id is provided in the request
    $user_id = isset($_POST['user_id']) ? intval($_POST['user_id']) : null;
    $parent_comment_id = isset($_POST['parent_comment_id']) ? $_POST['parent_comment_id'] : null;
    $sub_parent = isset($_POST['sub_parent']) ? $_POST['sub_parent'] : null;
    $comment_text = isset($_POST['comment_text']) ? $_POST['comment_text'] : null;
    $post_id = isset($_POST['post_id']) ? $_POST['post_id'] : null;

    if ($user_id !== null)
    {
        // Sanitize inputs
        $comment_text = $general->baseencode($comment_text);

        // Check if the parent comment id is 0 or null
        if ($parent_comment_id == 0 || $parent_comment_id == null)
        {
            $parent_comment_id = NULL;
        }
        if ($sub_parent == 0 || $sub_parent == null)
        {
            $sub_parent = NULL;
        }
        $where2 = " and id=" . $post_id;


        $post_arr = $general->get_Onerow("user_posts", $where2);
        $other_user = $post_arr['user_id'];
        // Insert the comment into the database
        if ($parent_comment_id != null)
        {

            if ($sub_parent != null)
            {
                $result = $general->ins_Row(
                    'user_comments',
                    'parent_comment_id, sub_parent, user_id, post_id,comment_text',
                    "'$parent_comment_id', '$sub_parent', '$user_id', '$post_id', '$comment_text'"
                );
                $parent_comm_arr = $general->get_Onerow("user_comments", " and id=" . $parent_comment_id);
                $sub_parent_comm_arr = $general->get_Onerow("user_comments", " and id=" . $sub_parent);

                $other_user = $sub_parent_comm_arr['user_id'];
                $type = "user_replied";
                if ($other_user != $user_id)
                {
                    $msg = $general->ins_Row(
                        'notifications',
                        'user_id,notification_type, post_id,other_user',
                        "'$other_user','$type' ,'$post_id', '$user_id'"
                    );
                }
            }
            else
            {
                $result = $general->ins_Row(
                    'user_comments',
                    'parent_comment_id, user_id, post_id,comment_text',
                    "'$parent_comment_id', '$user_id', '$post_id', '$comment_text'"
                );
                $parent_comm_arr = $general->get_Onerow("user_comments", " and id=" . $parent_comment_id);

                $other_user = $parent_comm_arr['user_id'];
                $type = "user_replied";
                if ($other_user != $user_id)
                {
                    $msg = $general->ins_Row(
                        'notifications',
                        'user_id,notification_type, post_id,other_user',
                        "'$other_user','$type' ,'$post_id', '$user_id'"
                    );
                }
            }
        }
        else
        {
            $result = $general->ins_Row(
                'user_comments',
                'user_id, post_id,comment_text',
                "'$user_id', '$post_id', '$comment_text'"
            );
            $type = "user_post_comment";
            $msg = $general->ins_Row(
                'notifications',
                'user_id,notification_type, post_id,other_user',
                "'$other_user','$type' ,'$post_id', '$user_id'"
            );
        }

        if ($result === "")
        {
            echo json_encode(['success' => true, 'message' => 'Comment added successfully']);
        }
        else
        {
            echo json_encode(['error' => 'Failed to add comment']);
        }
    }
    else
    {
        echo json_encode(['error' => 'Missing user_id parameter']);
    }
}
else
{
    // Invalid request method
    echo json_encode(['error' => 'Invalid request method']);
}
