<?php
require_once("cors.php");
require_once("includes/general.class.php");

$general = new general();

if ($_SERVER['REQUEST_METHOD'] === 'GET')
{
    $challenge_id = isset($_GET['challenge_id']) ? $_GET['challenge_id'] : null;
    $people_data_id = isset($_GET['people_data_id']) ? $_GET['people_data_id'] : null;
    $user_id = isset($_GET['user_id']) ? $_GET['user_id'] : null;
    $owner = isset($_GET['owner']) ? $_GET['owner'] : null;
    $task_id = isset($_GET['task_id']) ? $_GET['task_id'] : null;

    // Ensure proper sanitation of input values to prevent SQL injection
    $challenge_id = intval($challenge_id);
    $people_data_id = intval($people_data_id);
    $user_id = intval($user_id);
    $owner = intval($owner);
    $task_id = intval($task_id);

    $people_data = $general->get_Onerow("people_data", " and id=" . $people_data_id);
    $where_contest = " and challenge_id=" . $challenge_id . " and task_id=" . $task_id . " and user_id=" . $owner;

    $contest_data = $general->get_Onerow("contest", $where_contest);

    $where = " and challenge_id=" . $challenge_id . " and task_id=" . $task_id . " and people_data_id=" . $people_data_id . " and user_id=" . $user_id;
    $people_likes = $general->get_Onerow("people_likes", $where);
    $contest_likes = null; // Initialize contest_likes variable

    if (!empty($contest_data))
    {
        $where_contest_likes = " and challenge_id=" . $challenge_id . " and task_id=" . $task_id . " and user_id=" . $user_id;
        $contest_likes = $general->get_Onerow("contest_likes", $where_contest_likes);
    }

    $data = array();

    $data['id2'] = $contest_data;
    $data['id3'] = $contest_likes;
    $data['id22'] = $people_data;
    $data['id33'] = $people_likes;
    $data['id4'] = $_GET;


    if (empty($people_likes))
    {
        $msg = $general->ins_Row(
            'people_likes',
            'challenge_id, people_data_id,task_id, user_id',
            "'$challenge_id', '$people_data_id', '$task_id', '$user_id'"
        );
        $other_user  = $people_data['user_id'];
        $type = "people_liked";
        if ($user_id != $other_user)
        {
            $msg = $general->ins_Row(
                'notifications',
                'user_id,notification_type, people_data_id,other_user',
                "'$other_user','$type' ,'$people_data_id', '$user_id'"
            );
        }
        if (!empty($contest_data)&& (empty( $contest_likes)))
        {
            $contest_id = $contest_data["id"];
            $msg = $general->ins_Row(
                'contest_likes',
                'challenge_id, contest_id, user_id,task_id',
                "'$challenge_id', '$contest_id', '$user_id', '$task_id'"
            );
            $update_contest = $general->upd_Row("contest", "like_count='" . ($contest_data['like_count'] + 1) . "'", "id=" . $contest_data['id']);
        }
        $update_follow = $general->upd_Row("people_data", "like_count='" . ($people_data['like_count'] + 1) . "'", "id=" . $people_data_id);

        $data['message'] = 'Row created successfully';
    }
    else
    {
        $msg = $general->del_Row("people_likes", "challenge_id=" . $challenge_id . " and task_id=" . $task_id . " and people_data_id=" . $people_data_id . " and user_id=" . $user_id);
        $update_follow = $general->upd_Row("people_data", "like_count='" . ($people_data['like_count'] - 1) . "'", "id=" . $people_data_id);
        if (!empty($contest_data) && !empty($contest_likes))
        {
            $contest_id = $contest_data["id"];
            $msg = $general->del_Row("contest_likes", "id=" . $contest_likes['id']);
            $update_contest = $general->upd_Row("contest", "like_count='" . ($contest_data['like_count'] - 1) . "'", "id=" . $contest_data['id']);
        }
        $data['message'] = 'Row deleted successfully';
    }

    if ($msg == "")
    {

        echo json_encode($data);
    }
}
else
{
    // Invalid request method
    echo json_encode(['error' => 'Invalid request method']);
}
